#include <stdio.h>


typedef struct fpu__reg {
  unsigned sigl;
  unsigned sigh;
  short exp;
} FPU_REG;


int FPU_u_div(FPU_REG *a, FPU_REG *b, FPU_REG *dest,
	      unsigned long control_word, unsigned char *sign);

#define PR_64_BITS 0x300
#define RC_RND 0x0000

#define FULL_PRECISION (PR_64_BITS | RC_RND | 0x3f)

int main()
{
  FPU_REG a = { 0x1b1b1b1b, 0xa3a3a3a3, 0 };
  FPU_REG b = { 0x0, 0xa0a0a0a1, 5 };
  FPU_REG c = { 0x12d49876, 0xa393afa3, 0 };
  FPU_REG d = { 0x7c636585, 0x940d7e29, 0 };
  FPU_REG e = { 0x2ea5ff75, 0x940d7e29, 0 };
  FPU_REG x;
  
  FPU_u_div(&a, &b, &x, FULL_PRECISION, 0);

  printf("%04x %08lx %08lx\n",
	 x.exp, x.sigh, x.sigl);
  
  FPU_u_div(&a, &c, &x, FULL_PRECISION, 0);

  printf("%04x %08lx %08lx\n",
	 x.exp, x.sigh, x.sigl);
  
  FPU_u_div(&d, &e, &x, FULL_PRECISION, 0);

  printf("%04x %08lx %08lx\n",
	 x.exp, x.sigh, x.sigl);

}


void FPU_exception(int n)
{

  printf("FPU_exception(%04x)\n", n);

}

void set_precision_flag_down() {}
void set_precision_flag_up() {}
void arith_overflow() {}

